<?php

/**
 * inf_general_mensual actions.
 *
 * @package    costeoConocCient
 * @subpackage inf_general_mensual
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_general_mensualActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' ORDER BY tab0.id_anhos, tab0.id_meses, case when LENGTH(TRIM(TRANSLATE(tab0.codigo, \'0123456789\',\' \'))) is null then 0 else 1 end, tab0.codigo, tab0.sgr';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_anhos = $request['id_anhos'];
            $id_meses = $request['id_meses'];

            /*
             * Variables opcionales
             */
            //id_proyectos
            if (isset($request['id_proyectos'])) {
                $whereProyectos = " AND tab0.id_proyectos = " . $request['id_proyectos'];
            } else {
                $whereProyectos = ' ';
            }
            //sgr - true por 1 y false por 0
            if (isset($request['sgr'])) {
                if ($request['sgr'] == 'true') {
                    //Si es true
                    $sgr = 1;
                    $whereSgr = " AND tab0.sgr = 1 ";
                } elseif ($request['sgr'] == '0') {
                    //Si es 0
                    $sgr = 0;
                    $whereSgr = " AND tab0.sgr = 0 ";
                } else {
                    //Si es false
                    $sgr = 0;
                    $whereSgr = " ";
                }
            } else {
                $whereSgr = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /**
             * Consulta de pagos por fecha y estado aprobado
             * Recurso: 0-ANM 1-SGR
             */
            $consulta_sql = <<<EOD
select
tab0.id_anhos,
tab0.id_meses,
tab0.id_proyectos,
tab0.codigo,
tab0.descripcion,
tab0.sgr,
sum(case when tab0.tipo = 1 then valor else 0 end) as valor_presup,
sum(case when tab0.tipo = 2 then valor else 0 end) as valor_person,
sum(valor) as valor_total,
tab0.mes
from(   
    
    select
    tab1.*
    from(   
        select
        
        1 as tipo,    
        tab0.id_anhos,
        tab0.id_meses,
        tab0.id_proyectos,
        tab0.codigo,
        tab0.descripcion,
        tab0.sgr,
        sum(valor) as valor,
        tab0.mes
        
        from(
        
            SELECT
            tab0.id_costeo_presup as id_costeo_presup,
            tab0.id_anhos as id_anhos,
            tab0.id_meses as id_meses,
            tab0.id_proyectos as id_proyectos,
            tab0.sgr as sgr, tab0.valor as valor,
            tab0.id_pago_obl as id_pago_obl,
            tab0.id_obligacion as id_obligacion,
            tab0.secuencia as secuencia,
            tab0.id_vigencia as id_vigencia,
            tab0.vigencia as vigencia,
            tab0.id_rp as id_rp,
            tab0.id_obligacion_val,
            tab0.mes as mes,
            tab0.codigo as codigo,
            tab0.descripcion as descripcion,
            tab0.nro_orden_pago as nro_orden_pago,
            tab0.fecha_proc as fecha_proc,
            tab0.id_asign as id_asign,
            tab0.id_obj_gasto as id_obj_gasto,
            tab0.id_cpo as id_cpo,
            tab0.codigo_obj as codigo_obj,
            tab0.descripcion_obj as descripcion_obj
        
            FROM CCG_COSTEO_PRESUP_V tab0
        
            WHERE
            tab0.id_anhos =  $id_anhos
            AND tab0.id_meses = $id_meses
            $whereProyectos
            $whereSgr
        
        )tab0
        
        group by
        tab0.id_anhos,
        tab0.id_meses,
        tab0.id_proyectos,
        tab0.codigo,
        tab0.descripcion,
        tab0.sgr,
        tab0.mes
    
    )tab1
    
    union
    
    select
    tab2.*
    from(   
    
        select
        
        2 as tipo,
        tab0.id_anhos,
        tab0.id_meses,
        tab0.id_proyectos,
        tab0.codigo,
        tab0.descripcion,
        tab0.sgr,
        sum(valor) as valor,
        tab0.mes
        
        from(
        
            SELECT
            tab0.id_costeo_personal,
            tab0.id_anhos,
            tab0.id_meses,
            tab0.id_proyectos,
            tab0.sgr,
            tab0.valor,
            tab0.id_tipo_doc,
            tab0.num_doc,
            tab0.valor_deven,
            tab0.valor_cesan,
            tab0.valor_aporte,
            tab0.dias_mes,
            tab0.porcentaje,
            tab0.id_recursos,
            tab0.fecha_ini,
            tab0.fecha_fin,
            tab0.mes,
            tab0.codigo,
            tab0.descripcion,
            tab0.razon_soc
        
            FROM CCG_COSTEO_PERSONAL_V tab0
        
            WHERE
            tab0.id_anhos =  $id_anhos
            AND tab0.id_meses = $id_meses
            $whereProyectos
            $whereSgr
        
        )tab0
        
        group by
        tab0.id_anhos,
        tab0.id_meses,
        tab0.id_proyectos,
        tab0.codigo,
        tab0.descripcion,
        tab0.sgr,
        tab0.mes
    
    )tab2

)tab0
        
group by
tab0.id_anhos,
tab0.id_meses,
tab0.id_proyectos,
tab0.codigo,
tab0.descripcion,
tab0.sgr,
tab0.mes    
EOD;

            /*
             * Sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (
                    
    $consulta_sql    
                    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

    $consulta_sql

    $sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_general_mensual] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
